; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_BEGRUESSUNG:
	; ZEILE1	
	rcall LCD_CLEAR
	ldi ZH, high(TEXT_BEGRUESSUNG_1*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_1*2)
	rcall ANZEIGE_TEXT

	; ZEILE2	
	rcall LCD_ZEILE2

	ldi ZH, high(TEXT_BEGRUESSUNG_2*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_2*2)
	rcall ANZEIGE_TEXT

	; ZEILE3	
	rcall LCD_ZEILE3

	ldi ZH, high(TEXT_BEGRUESSUNG_3*2)	; TEXT	
	ldi ZL,  low(TEXT_BEGRUESSUNG_3*2)
	rcall ANZEIGE_TEXT

	; ZEILE4	
	rcall LCD_ZEILE4
	ldi ZH, high(TEXT_BEGRUESSUNG_4*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_4*2)
	rcall ANZEIGE_TEXT

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_BEISPIEL:
	; ZEILE1	
	rcall LCD_CLEAR

	ldi temp,65
ANZEIGE_BEISPIEL_z1:
	rcall LCD_DATA
	rcall wait_100ms
	inc temp
	cpi temp,65+20
	brne ANZEIGE_BEISPIEL_z1

	; ZEILE2	
	rcall LCD_ZEILE2

	ldi temp,85
ANZEIGE_BEISPIEL_z2:
	rcall LCD_DATA
	rcall wait_100ms
	inc temp
	cpi temp,85+20
	brne ANZEIGE_BEISPIEL_z2

	; ZEILE3	
	rcall LCD_ZEILE3

	ldi temp,105
ANZEIGE_BEISPIEL_z3:
	rcall LCD_DATA
	rcall wait_100ms
	inc temp
	cpi temp,105+20
	brne ANZEIGE_BEISPIEL_z3


	; ZEILE4	
	rcall LCD_ZEILE4

	ldi temp,125
ANZEIGE_BEISPIEL_z4:
	rcall wait_100ms
	rcall LCD_DATA
	inc temp
	cpi temp,125+20
	brne ANZEIGE_BEISPIEL_z4


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; LCD-INITIALISIERUNG															
LCD_INITIALISIERUNG:
;	send_nibble(0x03); //Be sure to	
;	send_nibble(0x03); //be in		
;	send_nibble(0x03); //8-Bit-Mode	
  	ldi temp, 0x03    
	OUT PORTB,TEMP
	rcall LCD_ENABLE
	rcall LCD_ENABLE
	rcall LCD_ENABLE
;	send_nibble(0x02); //Switch to 4 Bit
    ldi temp, 0x02        ;4bit-Modus einstellen
	OUT PORTB,TEMP
	rcall LCD_ENABLE
;	WriteIns(0x28);//4-Bit-Mode
    ldi temp, 0x28
 	rcall LCD_COMMAND
;	WriteIns(0x08);//display off
    ldi temp, (0x08)
	rcall LCD_COMMAND
;	WriteIns(0x06);//entry mode set increment cursor by 1 not shifting display
    ldi temp, 0x06
 	rcall LCD_COMMAND
;	WriteIns(0x17);//Character mode and internel power on
    ldi temp, (0x17)
 	rcall LCD_COMMAND
;	WriteIns(0x01);//clear display
    ldi temp, (0x01)
 	rcall LCD_COMMAND
;	WriteIns(0x02);//return home
    ldi temp, (0x02)
 	rcall LCD_COMMAND
;	WriteIns(0x0C); //display on
    ldi temp, (0x0C)
 	rcall LCD_COMMAND
ret
;######################################################################## 
;######################################################################## 
;																		  
;erzeugt den Enable-Puls												  
;																		  
LCD_ENABLE:
	sbi LCD_E_PORT, LCD_E       ; Enable high		
    ; kurze PAUSE		
	rcall wait_5us
	cbi LCD_E_PORT, LCD_E       ; Enable low		
	rcall wait_50us              ; kurze PAUSE		
ret                          
;######################################################################## 
;######################################################################## 
;######################################################################## 
; sendet ein Datenbyte an das LCD										  
;																		  
; INPUT: temp															  
;																		  
; rcall LCD_DATA			; DATENBYTE an LCD inp: temp 				  
;																		  
LCD_DATA:
	push temp             	; "Sicherungskopie" 			
	push temp             	; "Sicherungskopie" 			
    swap temp               ; Vertauschen					
   	andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						
    
	sbi LCD_RS_PORT, LCD_RS ; RS ein (high)					
	rcall lcd_enable        ; Enable-Routine aufrufen		
                         
    pop temp				; Kopie wieder laden	 		
   	andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						
   
    sbi LCD_RS_PORT, LCD_RS ; RS ein  (high)	     		
	rcall lcd_enable        ; Enable-Routine aufrufen		
    pop temp				; Kopie wieder laden	 		

ret				                       
;######################################################################## 
;######################################################################## 
;######################################################################## 
;sendet einen Befehl an das LCD;wie lcd_data, nur ohne RS zu setzen		  
;																		  
; INPUT: temp															  
;																		  
LCD_COMMAND:                            
    push temp				; "Sicherungskopie" 			
    push temp				; "Sicherungskopie" 			
    swap temp				; Vertauschen					
    andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						

    cbi LCD_RS_PORT, LCD_RS ; RS aus (low)					
	rcall lcd_enable		; Enable-Routine aufrufen		
           
	pop temp				; Kopie wieder laden			
  	andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						
           
	cbi LCD_RS_PORT, LCD_RS ; RS aus (low)       			
	rcall lcd_enable		; Enable-Routine aufrufen		
	rcall wait_5ms			; Pause (wichtig)				
    pop temp				; Kopie wieder laden	 
 ret
;######################################################################## 
;########################################################################
;######################################################################## 
ANZEIGE_TEXT:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	breq ANZEIGE_TEXT_e 	; Sprung
	rcall LCD_DATA			; Anzeige
	rjmp ANZEIGE_TEXT
	ANZEIGE_TEXT_e:
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; Display lschen														  
LCD_CLEAR:
   	ldi temp, 0b00000001
    rcall lcd_command
	rcall wait_5ms			; Pause (wichtig)				
	rcall LCD_GO_HOME
ret
;######################################################################## 
; KURSOR GO-HOME														  
LCD_GO_HOME:
 	ldi temp, 0b00000010
	rcall lcd_command 
ret
;######################################################################## 
LCD_ZEILE2:
 			ldi temp, 0b11000000 
			rcall lcd_command 
ret
; KURSOR Sprung in ZEILE3												  
LCD_ZEILE3:
	ldi temp, 0b10010100
	rcall lcd_command 
ret
;######################################################################## 
LCD_ZEILE4:
	ldi temp, 0b11010100
	rcall lcd_command 
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_SPACE:
	ldi temp, ' '		; SPACE
	rcall LCD_DATA	
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_PUNKT:
	ldi temp, '.'		; PUNKT
	rcall LCD_DATA	
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_3_PUNKT:
	ldi temp, '.'		; PUNKT
	rcall LCD_DATA	
	rcall LCD_DATA	
	rcall LCD_DATA	
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_DOPPEL_PUNKT:
	ldi temp, ':'		; DOPPELPUNKT
	rcall LCD_DATA	
ret

