

;												
; STANDARD Einstellungen fr ATmega8			
; Bernhard.Erfurt@gmx.de						
; 26.10/2011									
;												
; LCD 16x2										
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> 										
; PB1 ==> 										
; PB2 ==> 										
; PB3 ==> 										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> 										
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												


; ATmega8 										
.include "m8def.inc"

; KONSTANTEN									
.equ TAKT		=1000000			; 1 MHz		

; LEDS 											
.equ LED_D_GRUEN		= 5
.equ LED_D_GELB			= 6
.equ LED_D_ROT			= 7
; LCD											
.equ LCD_PORT				= PORTB
.equ LCD_D0					= 0
.equ LCD_D1					= 1
.equ LCD_D2					= 2
.equ LCD_D3					= 3
; LCD RS (Befehl/DATEN)							
.equ LCD_RS_PORT			= PORTC
.equ LCD_RS					= 2
; LCD_ENABLE									
.equ LCD_E_PORT				= PORTC
.equ LCD_E					= 3

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					= 0x0060			; 0x0060 START Adresse 		

; REGISTER										
.def NULL 	= R10
.def EINS 	= R11
.def VOLL	= R12

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25





.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	wdr	
	cbi PORTD,LED_D_ROT		; LED ROT			
INTERRUPT_ERROR_SCHLEIFE:
	rjmp INTERRUPT_ERROR_SCHLEIFE

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	


; PORT B initialisieren								
	ldi temp, 0b00001111	; DISPLAY	
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00001100
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b11100000	; LEDs
	out DDRD, temp
; PORT D setzen										
	out PORTD, temp				
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp



; LCD_INITIALISIERUNG								
	rcall LCD_INITIALISIERUNG
; LED												
	cbi PORTD, LED_D_GRUEN

; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	rcall ANZEIGE_BEGRUESSUNG
	rcall wait_1s
	rcall ANZEIGE_BEISPIEL
	rcall wait_1s
	rcall LCD_CLEAR
	rcall wait_1s
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "OLED_OLED_4x20.asm"
.include "OLED_WAIT.asm"		; 
; ##############################################################################
; ##############################################################################
; ##############################################################################


TEXT_BEGRUESSUNG_1:
.db "OLED-DISPLAY    4x20",0

TEXT_BEGRUESSUNG_2:
.db "EAW204-XLG",0

TEXT_BEGRUESSUNG_3:
.db "ATmega8 1.000.000MHz",0

TEXT_BEGRUESSUNG_4:
.db "04.11.2011 Version-1",0


